## ros-humble-system-modes-examples 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(system_modes_examples)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(system_modes REQUIRED)

# drive_base
add_executable(drive_base src/drive_base.cpp)
target_include_directories(drive_base PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(drive_base
  "system_modes"
)
install(TARGETS drive_base
  EXPORT export_${PROJECT_NAME}
  DESTINATION lib/${PROJECT_NAME})

# manipulator
add_executable(manipulator src/manipulator.cpp)
target_include_directories(manipulator PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(manipulator
  "system_modes"
)
install(TARGETS manipulator
  EXPORT export_${PROJECT_NAME}
  DESTINATION lib/${PROJECT_NAME})

  # launch
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME}/)

# SMH file
install(FILES example_modes.yaml
  DESTINATION share/${PROJECT_NAME}/
)
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME}/)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_gmock REQUIRED)
  # the following line skips the linter which checks for copyrights
  # remove the line when a copyright and license is present in all source files
  set(ament_cmake_copyright_FOUND TRUE)
  # the following line skips cpplint (only works in a git repo)
  # remove the line when this package is a git repo
  set(ament_cmake_cpplint_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

=== debian/changelog ===
ros-humble-system-modes-examples (0.9.0-6jammy) jammy; urgency=high

  * More flexibility in specifying the default mode, any mode can be now default mode
    https://github.com/micro-ROS/system_modes/issues/69

 -- Arne Nordmann <arne.nordmann@bosch.com>  Mon, 20 Jul 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.8.0-6jammy) jammy; urgency=high

  * Launch integration, i.e. launch actions, events, and event handlers for system modes

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 21 Apr 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.7.1-6jammy) jammy; urgency=high

  * Improved metadata for ROS 2 package releases

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 21 Apr 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.7.0-6jammy) jammy; urgency=high

  * Launch tests now using launch_ros node action https://github.com/micro-ROS/system_modes/pull/72
  * Introduced separate interface package, system_modes_msgs https://github.com/micro-ROS/system_modes/pull/74

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 21 Apr 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.6.0-6jammy) jammy; urgency=high

  * Introduced mode observer https://github.com/micro-ROS/system_modes/issues/59
  * Mode manager prevents redundant mode changes https://github.com/micro-ROS/system_modes/pull/67
  * Minor bugfix in inference

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 15 Mar 2020 23:00:00 -0000

ros-humble-system-modes-examples (0.5.0-6jammy) jammy; urgency=high

  * Atomic parameter setting https://github.com/micro-ROS/system_modes/issues/59
  * Bug fixing
  * More tests

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 15 Mar 2020 23:00:00 -0000

ros-humble-system-modes-examples (0.4.2-6jammy) jammy; urgency=high

  * Error handling and rules feature no longer experimental
  * Fixed bugs in monitor and tests

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 16 Dec 2020 23:00:00 -0000

ros-humble-system-modes-examples (0.4.1-6jammy) jammy; urgency=high

  * Include experimental error handling and rules feature
  * https://github.com/micro-ROS/system_modes/issues/13
  * CI for ubuntu 20.04 ROS 2 rolling

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 28 Oct 2020 23:00:00 -0000

ros-humble-system-modes-examples (0.4.0-6jammy) jammy; urgency=high

  * publish inferred state and mode transitions
  * https://github.com/micro-ROS/system_modes/issues/42

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 29 Sep 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.3.0-6jammy) jammy; urgency=high

  * removed boost dependencies (was: program options)
  * changed mode service specifications (less redundancy)
  * https://github.com/micro-ROS/system_modes/issues/24

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 22 Jul 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.2.3-6jammy) jammy; urgency=high

  * improved StateAndMode struct
  * testing

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 22 Jul 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.2.2-6jammy) jammy; urgency=high

  * introduced StateAndMode struct to bundle lifecycle state and system mode

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 12 Jul 2020 22:00:00 -0000

ros-humble-system-modes-examples (0.2.0-6jammy) jammy; urgency=high

  * integration with ROS 2 launch
  * updated docs

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 12 Feb 2020 23:00:00 -0000

ros-humble-system-modes-examples (0.1.6-6jammy) jammy; urgency=high

  * fixed QoS configuration for parameter event subscribers

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 30 Oct 2019 23:00:00 -0000

ros-humble-system-modes-examples (0.1.2-6jammy) jammy; urgency=high

  * fixed dependencies in package.xml

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 17 Mar 2019 23:00:00 -0000

ros-humble-system-modes-examples (0.1.1-6jammy) jammy; urgency=high

  * first public release for ROS 2 system modes

 -- Arne Nordmann <arne.nordmann@bosch.com>  Thu, 07 Mar 2019 23:00:00 -0000

=== debian/control ===
Source: ros-humble-system-modes-examples
Section: misc
Priority: optional
Maintainer: Arne Nordmann <arne.nordmann@bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-cmake-cppcheck <!nocheck>, ros-humble-ament-cmake-cpplint <!nocheck>, ros-humble-ament-cmake-flake8 <!nocheck>, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-pep257 <!nocheck>, ros-humble-ament-cmake-uncrustify <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-system-modes, ros-humble-system-modes-msgs, ros-humble-ros-workspace
Homepage: https://micro.ros.org/docs/concepts/client_library/lifecycle_and_system_modes/
Standards-Version: 3.9.2

Package: ros-humble-system-modes-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-launch, ros-humble-launch-system-modes, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-ros2launch, ros-humble-system-modes, ros-humble-system-modes-msgs, ros-humble-ros-workspace
Description: Example systems and according launch files for the system_modes package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-system-modes-examples//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
